function plot_2DstateTrace(trc, fun, XYdom)
% trc    2 x Niter  state_trace for Niter iterations typically.
% 1. contour plot of the objective function fun, whcih takes array inputs
%    F = fun(X,Y), where X,Y,F are matrices of same size
% 2. superimposed on this contour plot is the trace of 2D state
% XYdom  1 x 4 vector [xmin, xmax, ymin, ymax] defining the XY-domain

[X,Y] = meshgrid(XYdom(1): .01 :XYdom(2), XYdom(3): .01 :XYdom(4));
f     = fun(X, Y);

contour(X,Y,f,80)  % Plot contours
axis(XYdom)
colormap(jet)
hold on
plot(trc(1,:), trc(2,:), 'r.-')
plot(trc(1,end), trc(2,end), 'rx')
xlabel('x')
ylabel('y')
return
%================
