% step_length_driver
% script:
% for studying different step length choices for steepest descent
% see comments in steep_Armijo.m for details
clear all
x0  = [-1; 2.9];  % inital point

for MOD = 0:2
  Nit0= 500;
  [xc, his, xrec] = steep_Armijo(x0, @Rosenbrock_optim, 1e-4, Nit0, MOD);
  Nit = size(his, 2);
  
  figure
  subplot(2,2,1)
  plot_2DstateTrace([xrec, xc], @Rosenbrock, [-2 2 -1 3])
  title('Steepest descent with Armijo condition ...')
  
  subplot(2,2,2)
  plot((1:Nit), his(2,:), 'b-', 'linewidth',2), hold on
  plot((1:Nit), log10(his(1,:)./his(1,1)), 'r-', 'linewidth',2)
  xlabel('iteration step')
  legend('# Armijo violations', 'log(misfit)', 'Location', 'East')
  legend('boxoff')
  if (MOD==0)     title('using Kelley''s choice of initial \lambda');
  elseif (MOD==1) title('using analytic step length (ASL)');
  else            title('using ASL with diag(H) only');
  end
end

